Index: trunk/src/VBox/Runtime/common/ioqueue/ioqueue-aiofile-provider.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/ioqueue/ioqueue-aiofile-provider.cpp	(revision 79952)
+++ trunk/src/VBox/Runtime/common/ioqueue/ioqueue-aiofile-provider.cpp	(revision 79983)
@@ -88,5 +88,5 @@
 /** @interface_method_impl{RTIOQUEUEPROVVTABLE,pfnQueueInit} */
 static DECLCALLBACK(int) rtIoQueueAioFileProv_QueueInit(RTIOQUEUEPROV hIoQueueProv, uint32_t fFlags,
-                                                        size_t cSqEntries, size_t cCqEntries)
+                                                        uint32_t cSqEntries, uint32_t cCqEntries)
 {
     RT_NOREF(fFlags, cCqEntries);
@@ -96,5 +96,5 @@
 
     pThis->cReqsToCommitMax = cSqEntries;
-    pThis->cReqsFreeMax     = (uint32_t)cSqEntries;
+    pThis->cReqsFreeMax     = cSqEntries;
     pThis->cReqsFree        = 0;
 
@@ -105,5 +105,5 @@
         if (RT_LIKELY(pThis->pahReqsFree))
         {
-            rc = RTFileAioCtxCreate(&pThis->hAioCtx, (uint32_t)cSqEntries, RTFILEAIOCTX_FLAGS_WAIT_WITHOUT_PENDING_REQUESTS);
+            rc = RTFileAioCtxCreate(&pThis->hAioCtx, cSqEntries, RTFILEAIOCTX_FLAGS_WAIT_WITHOUT_PENDING_REQUESTS);
             if (RT_SUCCESS(rc))
                 return VINF_SUCCESS;
@@ -251,6 +251,6 @@
                 RTFILEAIOREQ hReq = ahReqs[i];
 
-                paCEvt[idxCEvt].rcReq = RTFileAioReqGetRC(hReq, NULL);
-                paCEvt[idxCEvt].pvUser = RTFileAioReqGetUser(hReq);
+                paCEvt[idxCEvt].rcReq    = RTFileAioReqGetRC(hReq, &paCEvt[idxCEvt].cbXfered);
+                paCEvt[idxCEvt].pvUser   = RTFileAioReqGetUser(hReq);
                 idxCEvt++;
 
Index: trunk/src/VBox/Runtime/common/ioqueue/ioqueue-stdfile-provider.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/ioqueue/ioqueue-stdfile-provider.cpp	(revision 79952)
+++ trunk/src/VBox/Runtime/common/ioqueue/ioqueue-stdfile-provider.cpp	(revision 79983)
@@ -102,7 +102,7 @@
 {
     /** Size of the submission queue in entries. */
-    size_t                      cSqEntries;
+    uint32_t                    cSqEntries;
     /** Size of the completion queue in entries. */
-    size_t                      cCqEntries;
+    uint32_t                    cCqEntries;
     /** Pointer to the submission queue base. */
     PRTIOQUEUESSQENTRY          paSqEntryBase;
@@ -257,5 +257,5 @@
 /** @interface_method_impl{RTIOQUEUEPROVVTABLE,pfnQueueInit} */
 static DECLCALLBACK(int) rtIoQueueStdFileProv_QueueInit(RTIOQUEUEPROV hIoQueueProv, uint32_t fFlags,
-                                                        size_t cSqEntries, size_t cCqEntries)
+                                                        uint32_t cSqEntries, uint32_t cCqEntries)
 {
     RT_NOREF(fFlags);
@@ -264,12 +264,12 @@
     int rc = VINF_SUCCESS;
 
-    pThis->cSqEntries    = cSqEntries;
-    pThis->cCqEntries    = cCqEntries;
-    pThis->idxSqProd = 0;
-    pThis->idxSqCons = 0;
-    pThis->idxCqProd = 0;
-    pThis->idxCqCons = 0;
-    pThis->fShutdown     = false;
-    pThis->fState        = 0;
+    pThis->cSqEntries = cSqEntries;
+    pThis->cCqEntries = cCqEntries;
+    pThis->idxSqProd  = 0;
+    pThis->idxSqCons  = 0;
+    pThis->idxCqProd  = 0;
+    pThis->idxCqCons  = 0;
+    pThis->fShutdown  = false;
+    pThis->fState     = 0;
 
     pThis->paSqEntryBase = (PRTIOQUEUESSQENTRY)RTMemAllocZ(cSqEntries * sizeof(RTIOQUEUESSQENTRY));
Index: trunk/src/VBox/Runtime/common/ioqueue/ioqueuebase.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/ioqueue/ioqueuebase.cpp	(revision 79952)
+++ trunk/src/VBox/Runtime/common/ioqueue/ioqueuebase.cpp	(revision 79983)
@@ -128,5 +128,5 @@
 
 RTDECL(int) RTIoQueueCreate(PRTIOQUEUE phIoQueue, PCRTIOQUEUEPROVVTABLE pProvVTable,
-                            uint32_t fFlags, size_t cSqEntries, size_t cCqEntries)
+                            uint32_t fFlags, uint32_t cSqEntries, uint32_t cCqEntries)
 {
     AssertPtrReturn(phIoQueue, VERR_INVALID_POINTER);
@@ -142,6 +142,6 @@
         pThis->pVTbl          = pProvVTable;
         pThis->hIoQueueProv   = (RTIOQUEUEPROV)&pThis->abInst[0];
-        pThis->cSqEntries     = (uint32_t)cSqEntries;
-        pThis->cCqEntries     = (uint32_t)cCqEntries;
+        pThis->cSqEntries     = cSqEntries;
+        pThis->cCqEntries     = cCqEntries;
         pThis->cReqsCommitted = 0;
         pThis->cReqsPrepared  = 0;