Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 80047)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1.qrc	(revision 80048)
@@ -417,4 +417,11 @@
         <file alias="log_viewer_options_16px.png">images/log_viewer_options_16px.png</file>
         <file alias="log_viewer_options_32px.png">images/log_viewer_options_32px.png</file>
+        <file alias="log_viewer_options_disabled_16px.png">images/log_viewer_options_disabled_16px.png</file>
+        <file alias="log_viewer_options_disabled_32px.png">images/log_viewer_options_disabled_32px.png</file>
+        <file alias="log_viewer_refresh_16px.png">images/log_viewer_refresh_16px.png</file>
+        <file alias="log_viewer_refresh_32px.png">images/log_viewer_refresh_32px.png</file>
+        <file alias="log_viewer_refresh_disabled_16px.png">images/log_viewer_refresh_disabled_16px.png</file>
+        <file alias="log_viewer_refresh_disabled_32px.png">images/log_viewer_refresh_disabled_32px.png</file>
+        <file alias="log_viewer_reset_font_16px.png">images/log_viewer_reset_font_16px.png</file>
     </qresource>
 </RCC>
Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc	(revision 80047)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x2.qrc	(revision 80048)
@@ -411,4 +411,10 @@
         <file alias="log_viewer_goto_previous_bookmark_16px_x2.png">images/x2/log_viewer_goto_previous_bookmark_16px_x2.png</file>
         <file alias="log_viewer_goto_selected_bookmark_16px_x2.png">images/x2/log_viewer_goto_selected_bookmark_16px_x2.png</file>
+        <file alias="log_viewer_options_16px_x2.png">images/x2/log_viewer_options_16px_x2.png</file>
+        <file alias="log_viewer_options_32px_x2.png">images/x2/log_viewer_options_32px_x2.png</file>
+        <file alias="log_viewer_options_disabled_16px_x2.png">images/x2/log_viewer_options_disabled_16px_x2.png</file>
+        <file alias="log_viewer_options_disabled_32px_x2.png">images/x2/log_viewer_options_disabled_32px_x2.png</file>
+        <file alias="log_viewer_refresh_16px_x2.png">images/x2/log_viewer_refresh_16px_x2.png</file>
+        <file alias="log_viewer_refresh_32px_x2.png">images/x2/log_viewer_refresh_32px_x2.png</file>
     </qresource>
 </RCC>
Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 80047)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 80048)
@@ -1,11 +1,4 @@
 <RCC>
     <qresource suffix="/">
-        <file alias="log_viewer_options_disabled_16px.png">images/log_viewer_options_disabled_16px.png</file>
-        <file alias="log_viewer_options_disabled_32px.png">images/log_viewer_options_disabled_32px.png</file>
-        <file alias="log_viewer_refresh_16px.png">images/log_viewer_refresh_16px.png</file>
-        <file alias="log_viewer_refresh_32px.png">images/log_viewer_refresh_32px.png</file>
-        <file alias="log_viewer_refresh_disabled_16px.png">images/log_viewer_refresh_disabled_16px.png</file>
-        <file alias="log_viewer_refresh_disabled_32px.png">images/log_viewer_refresh_disabled_32px.png</file>
-        <file alias="log_viewer_reset_font_16px.png">images/log_viewer_reset_font_16px.png</file>
         <file alias="log_viewer_save_16px.png">images/log_viewer_save_16px.png</file>
         <file alias="log_viewer_save_32px.png">images/log_viewer_save_32px.png</file>
@@ -266,4 +259,17 @@
         <file alias="snapshot_take_disabled_16px.png">images/snapshot_take_disabled_16px.png</file>
         <file alias="snapshot_take_disabled_32px.png">images/snapshot_take_disabled_32px.png</file>
+        <file alias="soft_keyboard_16px.png">images/soft_keyboard_16px.png</file>
+        <file alias="soft_keyboard_32px.png">images/soft_keyboard_32px.png</file>
+        <file alias="soft_keyboard_layout_copy_16px.png">images/soft_keyboard_layout_copy_16px.png</file>
+        <file alias="soft_keyboard_layout_copy_disabled_16px.png">images/soft_keyboard_layout_copy_disabled_16px.png</file>
+        <file alias="soft_keyboard_layout_edit_16px.png">images/soft_keyboard_layout_edit_16px.png</file>
+        <file alias="soft_keyboard_layout_edit_disabled_16px.png">images/soft_keyboard_layout_edit_disabled_16px.png</file>
+        <file alias="soft_keyboard_layout_list_16px.png">images/soft_keyboard_layout_list_16px.png</file>
+        <file alias="soft_keyboard_layout_remove_16px.png">images/soft_keyboard_layout_remove_16px.png</file>
+        <file alias="soft_keyboard_layout_remove_disabled_16px.png">images/soft_keyboard_layout_remove_disabled_16px.png</file>
+        <file alias="soft_keyboard_layout_save_16px.png">images/soft_keyboard_layout_save_16px.png</file>
+        <file alias="soft_keyboard_layout_save_disabled_16px.png">images/soft_keyboard_layout_save_disabled_16px.png</file>
+        <file alias="soft_keyboard_reset_16px.png">images/soft_keyboard_reset_16px.png</file>
+        <file alias="soft_keyboard_settings_16px.png">images/soft_keyboard_settings_16px.png</file>
         <file alias="sort_16px.png">images/sort_16px.png</file>
         <file alias="sort_disabled_16px.png">images/sort_disabled_16px.png</file>
Index: /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x2.qrc
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x2.qrc	(revision 80047)
+++ /trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x2.qrc	(revision 80048)
@@ -1,10 +1,4 @@
 <RCC>
     <qresource suffix="/">
-        <file alias="log_viewer_options_16px_x2.png">images/x2/log_viewer_options_16px_x2.png</file>
-        <file alias="log_viewer_options_32px_x2.png">images/x2/log_viewer_options_32px_x2.png</file>
-        <file alias="log_viewer_options_disabled_16px_x2.png">images/x2/log_viewer_options_disabled_16px_x2.png</file>
-        <file alias="log_viewer_options_disabled_32px_x2.png">images/x2/log_viewer_options_disabled_32px_x2.png</file>
-        <file alias="log_viewer_refresh_16px_x2.png">images/x2/log_viewer_refresh_16px_x2.png</file>
-        <file alias="log_viewer_refresh_32px_x2.png">images/x2/log_viewer_refresh_32px_x2.png</file>
         <file alias="log_viewer_refresh_disabled_16px_x2.png">images/x2/log_viewer_refresh_disabled_16px_x2.png</file>
         <file alias="log_viewer_refresh_disabled_32px_x2.png">images/x2/log_viewer_refresh_disabled_32px_x2.png</file>
@@ -266,4 +260,17 @@
         <file alias="snapshot_take_disabled_16px_x2.png">images/x2/snapshot_take_disabled_16px_x2.png</file>
         <file alias="snapshot_take_disabled_32px_x2.png">images/x2/snapshot_take_disabled_32px_x2.png</file>
+        <file alias="soft_keyboard_16px_x2.png">images/x2/soft_keyboard_16px_x2.png</file>
+        <file alias="soft_keyboard_32px_x2.png">images/x2/soft_keyboard_32px_x2.png</file>
+        <file alias="soft_keyboard_layout_copy_16px_x2.png">images/x2/soft_keyboard_layout_copy_16px_x2.png</file>
+        <file alias="soft_keyboard_layout_copy_disabled_16px_x2.png">images/x2/soft_keyboard_layout_copy_disabled_16px_x2.png</file>
+        <file alias="soft_keyboard_layout_edit_16px_x2.png">images/x2/soft_keyboard_layout_edit_16px_x2.png</file>
+        <file alias="soft_keyboard_layout_edit_disabled_16px_x2.png">images/x2/soft_keyboard_layout_edit_disabled_16px_x2.png</file>
+        <file alias="soft_keyboard_layout_list_16px_x2.png">images/x2/soft_keyboard_layout_list_16px_x2.png</file>
+        <file alias="soft_keyboard_layout_remove_16px_x2.png">images/x2/soft_keyboard_layout_remove_16px_x2.png</file>
+        <file alias="soft_keyboard_layout_remove_disabled_16px_x2.png">images/x2/soft_keyboard_layout_remove_disabled_16px_x2.png</file>
+        <file alias="soft_keyboard_layout_save_16px_x2.png">images/x2/soft_keyboard_layout_save_16px_x2.png</file>
+        <file alias="soft_keyboard_layout_save_disabled_16px_x2.png">images/x2/soft_keyboard_layout_save_disabled_16px_x2.png</file>
+        <file alias="soft_keyboard_reset_16px_x2.png">images/x2/soft_keyboard_reset_16px_x2.png</file>
+        <file alias="soft_keyboard_settings_16px_x2.png">images/x2/soft_keyboard_settings_16px_x2.png</file>
         <file alias="sort_16px_x2.png">images/x2/sort_16px_x2.png</file>
         <file alias="sort_disabled_16px_x2.png">images/x2/sort_disabled_16px_x2.png</file>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolRuntime.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolRuntime.cpp	(revision 80047)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolRuntime.cpp	(revision 80048)
@@ -1553,5 +1553,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowSoftKeyboard(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/keyboard_settings_16px.png", ":/keyboard_settings_disabled_16px.png", true)
+        : UIActionSimple(pParent, UIIconPool::iconSet(":/soft_keyboard_16px.png"), true)
     {}
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 80047)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 80048)
@@ -1339,20 +1339,20 @@
 
     m_pEditLayoutButton = new QToolButton;
-    m_pEditLayoutButton->setIcon(UIIconPool::iconSet(":/keyboard_settings_16px.png"));
+    m_pEditLayoutButton->setIcon(UIIconPool::iconSet(":/soft_keyboard_layout_edit_16px.png", ":/soft_keyboard_layout_edit_disabled_16px.png"));
     pButtonsLayout->addWidget(m_pEditLayoutButton);
     connect(m_pEditLayoutButton, &QToolButton::clicked, this, &UILayoutSelector::sigShowLayoutEditor);
 
     m_pCopyLayoutButton = new QToolButton;
-    m_pCopyLayoutButton->setIcon(UIIconPool::iconSet(":/vm_clone_16px.png"));
+    m_pCopyLayoutButton->setIcon(UIIconPool::iconSet(":/soft_keyboard_layout_copy_16px.png", ":/soft_keyboard_layout_copy_disabled_16px.png"));
     pButtonsLayout->addWidget(m_pCopyLayoutButton);
     connect(m_pCopyLayoutButton, &QToolButton::clicked, this, &UILayoutSelector::sigCopyLayout);
 
     m_pSaveLayoutButton = new QToolButton;
-    m_pSaveLayoutButton->setIcon(UIIconPool::iconSet(":/vm_save_state_16px.png"));
+    m_pSaveLayoutButton->setIcon(UIIconPool::iconSet(":/soft_keyboard_layout_save_16px.png", ":/soft_keyboard_layout_save_disabled_16px.png"));
     pButtonsLayout->addWidget(m_pSaveLayoutButton);
     connect(m_pSaveLayoutButton, &QToolButton::clicked, this, &UILayoutSelector::sigSaveLayout);
 
     m_pDeleteLayoutButton = new QToolButton;
-    m_pDeleteLayoutButton->setIcon(UIIconPool::iconSet(":/file_manager_delete_16px.png"));
+    m_pDeleteLayoutButton->setIcon(UIIconPool::iconSet(":/soft_keyboard_layout_remove_16px.png", ":/soft_keyboard_layout_remove_disabled_16px.png"));
     pButtonsLayout->addWidget(m_pDeleteLayoutButton);
     connect(m_pDeleteLayoutButton, &QToolButton::clicked, this, &UILayoutSelector::sigDeleteLayout);
@@ -3282,5 +3282,5 @@
     if (m_pLayoutListButton)
     {
-        m_pLayoutListButton->setIcon(UIIconPool::iconSet(":/file_manager_properties_24px.png"));
+        m_pLayoutListButton->setIcon(UIIconPool::iconSet(":/soft_keyboard_layout_list_16px.png", ":/soft_keyboard_layout_list_disabled_16px.png"));
         m_pLayoutListButton->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
         const int iIconMetric = QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize);
@@ -3294,5 +3294,5 @@
     if (m_pSettingsButton)
     {
-        m_pSettingsButton->setIcon(UIIconPool::iconSet(":/vm_settings_16px.png"));
+        m_pSettingsButton->setIcon(UIIconPool::iconSet(":/soft_keyboard_settings_16px.png", ":/soft_keyboard_settings_disabled_16px.png"));
         m_pSettingsButton->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
         const int iIconMetric = QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize);
@@ -3306,5 +3306,5 @@
     if (m_pResetButton)
     {
-        m_pResetButton->setIcon(UIIconPool::iconSet(":/hd_release_16px.png"));
+        m_pResetButton->setIcon(UIIconPool::iconSet(":/soft_keyboard_reset_16px.png"));
         m_pResetButton->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
         const int iIconMetric = QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize);
@@ -3840,5 +3840,5 @@
 void UISoftKeyboard::configure()
 {
-    setWindowIcon(UIIconPool::iconSet(":/keyboard_24px.png"));
+    setWindowIcon(UIIconPool::iconSet(":/soft_keyboard_16px.png"));
     if (m_pKeyboardWidget && m_pSettingsWidget)
     {